module Sound.Tidal.ParVagues.Control (
  midiOn,
  midiOff,
  midiNo,
  midiDJF,
  midiG,
  midiG'
) where

  import Sound.Tidal.Context
  import Sound.Tidal.Scales
  import Sound.Tidal.Chords

  -- Midi boolean buttons
  midiOn    ch    pat = someCyclesBy ch             pat
  midiOff   ch    pat = someCyclesBy (1 - ch)       pat
  midiNo    c1 c2 pat = someCyclesBy (1 - c1 - c2)  pat

  -- Parameterized DJF
  _LPF lMin lMax ch = (# lpf (min lMax ((range lMin ((lMax*2) - lMin) ch))))
  _HPF hMin hMax ch = (# hpf (max hMin (min hMax (range (hMin - hMax) (hMax - hMin) ch))))
  midiDJF   ch lMin lMax hMin hMax = (_LPF lMin lMax ch) . (_HPF hMin hMax ch)

  -- Midi gain control (faders)
  _gainG ch gFactor = (gain (gf * "^77" * ch)) -- gain Global
  midiG' ch l h
  midiG
  -- TODO Finir gain control
  let gG a = (gain (gF * "^77" * a)) -- gain Global
  let gM' l h a = (gG (range l h a)) -- gain Modéré
  let gM a = (gM' 0.2 0.8 a) -- gain Modéré doux
